import tkinter
import random

# キー入力
key = ""
koff = False
def key_down(e):
    global key, koff
    key = e.keysym
    koff = False

def key_up(e):
#    global koff # Mac
#    koff = True # Mac
    global key # Win
    key = ""   # Win


DIR_UP = 0
DIR_DOWN = 1
DIR_LEFT = 2
DIR_RIGHT = 3
# ANIMATION = [0, 1, 0, 2]
img_1 = [0, 1, 0, 2]    # daruma のイメージ用
img_2 = [1, 1, 0, 0, 1, 1, 2, 2]    # oni0 のイメージ用
img_3 = [2, 2, 1, 1, 0, 0, 1, 1]    # oni1
img_4 = [0, 0, 0, 1, 1, 2, 2, 2, 1, 1]  
idx = 0
tmr = 0
stage = 0
get_p = 0
time_p = 0
time_px = 0
get_r = 0
time_r = 0
time_rx = 0

ao_x = 0
ao_y = 0
ao_d = 0
ao_a = 0
ao_sx = 0
ao_sy = 0
ao_sd = 0
ao_sa = 0

red_x = 0
red_y = 0
red_d = 0
red_a = 0
red_sx = 0
red_sy = 0
red_sd = 0
red_sa = 0

oni0_x = 0
oni0_y = 0
oni0_d = 0
oni0_a = 0
oni0_sx = 0
oni0_sy = 0
oni0_sd = 0
oni0_sa = 0

oni1_x = 0
oni1_y = 0
oni1_d = 0
oni1_a = 0
oni1_sx = 0
oni1_sy = 0
oni1_sd = 0
oni1_sa = 0

oni2_x = 0
oni2_y = 0
oni2_d = 0
oni2_a = 0
oni2_sx = 0
oni2_sy = 0
oni2_sd = 0
oni2_sa = 0

map_data = [] 

def set_stage(): # ステージのセット
    global map_data, ao_sx, ao_sy, ao_sa, ao_sd, red_sx, red_sy, red_sa, red_sd
    global oni0_sx, oni0_sy, oni0_sd
    global oni1_sx, oni1_sy, oni1_sd
    global oni2_sx, oni2_sy, oni2_sd    

    map_data = [
    [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
    [0,0,1,1,1,0,2,1,1,1,1,1,1,3,0,2,0,0,3,2,3,0],
    [0,0,1,0,1,0,0,1,0,0,2,0,0,1,1,1,1,0,1,0,1,0],
    [0,0,0,0,1,2,3,1,0,0,1,0,0,1,0,0,1,0,2,3,2,0],
    [0,0,0,0,1,0,0,1,0,0,3,0,0,2,0,0,1,1,1,2,3,0],
    [0,0,3,1,1,0,0,1,0,2,1,0,0,1,3,0,1,0,2,3,2,0],
    [0,0,1,0,1,1,1,1,0,3,2,3,2,3,2,0,1,0,0,1,0,0],
    [0,0,2,1,1,0,0,1,0,2,1,0,0,1,3,0,1,0,3,2,3,0],        
    [0,0,0,0,1,0,0,1,0,0,2,0,0,3,0,0,1,1,1,3,2,0],
    [0,0,0,0,1,3,2,1,0,0,1,0,0,1,0,0,1,0,3,2,3,0],
    [0,0,1,0,1,0,0,1,0,0,3,0,0,1,1,1,1,0,1,0,1,0],
    [0,0,1,1,1,0,3,1,1,1,1,1,1,2,0,3,0,0,2,3,2,0],
    [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
    ]

    oni0_sx = 990
    oni0_sy = 390        
    oni0_sd = 3         
    oni1_sx = 1170
    oni1_sy = 270    
    oni1_sd = 0      # 上
    oni2_sx = 690
    oni2_sy = 390    
    oni2_sd = 3     # 右     
    if stage == 0:      # ＜stage 0＞
        ao_sx = 150
        ao_sy = 630
        ao_sa = 0
        ao_sd = 1
        red_sx = 150
        red_sy = 150
    else:               # ＜stage 1＞
        red_sx = 150
        red_sy = 150
        red_sa = 1
        red_sd = 0

def set_pos(): # スタート位置 
    global ao_x, ao_y, ao_d, ao_a
    global red_x, red_y, red_d, red_a, red_sd, red_sa
    global oni0_x, oni0_y, oni0_d, oni0_a
    global oni1_x, oni1_y, oni1_d, oni1_a
    global oni2_x, oni2_y, oni2_d, oni2_a  
    oni0_x = oni0_sx
    oni0_y = oni0_sy
    oni0_d = oni0_sd
    oni0_a = 0
    oni1_x = oni1_sx
    oni1_y = oni1_sy
    oni1_d = oni1_sd
    oni1_a = 1
    oni2_x = oni2_sx
    oni2_y = oni2_sy
    oni2_d = oni2_sd
    oni2_a = 3    
    ao_x = ao_sx
    ao_y = ao_sy
    ao_d = ao_sd
    ao_a = 3
    red_x = red_sx
    red_y = red_sy
    red_d = red_sd
    red_a = 1

def draw_txt(txt, x, y, siz, col): # 影付き文字
    fnt = ("Times New Roman", siz, "bold")
    canvas.create_text(x+2, y+2, text=txt, fill="black", font=fnt, tag="SCREEN")
    canvas.create_text(x, y, text=txt, fill=col, font=fnt, tag="SCREEN")


def draw_screen(): # ゲーム画面を描く
    global time_px, time_rx
    canvas.delete("SCREEN")
    for y in range(13):
        for x in range(22):
            canvas.create_image(x*60+30, y*60+30, image=img_bg[map_data[y][x]], tag="SCREEN")
    canvas.create_image(ao_x, ao_y, image=img_ao[ao_a], tag="SCREEN")
    canvas.create_image(red_x, red_y, image=img_red[red_a], tag="SCREEN")
    canvas.create_image(oni0_x, oni0_y, image=img_oni0[oni0_a], tag="SCREEN")
    canvas.create_image(oni1_x, oni1_y, image=img_oni1[oni1_a], tag="SCREEN")
    canvas.create_image(oni2_x, oni2_y, image=img_oni1[oni1_a], tag="SCREEN")
    draw_txt("ゲット "+str(get_r), 110, 210, 25, "red")
    draw_txt("残り時間 "+str(time_rx), 110, 250, 25, "green")
    draw_txt("ゲット "+str(get_p), 110, 520, 25, "blue")
    draw_txt("残り時間 "+str(time_px), 110, 560, 25, "green")   


def check_wall(cx, cy, di, dot): # 各方向に壁があるか調べる
    chk = False
    if di == DIR_UP:
        mx = int((cx-30)/60)
        my = int((cy-30-dot)/60)
        if map_data[my][mx] == 0: # 左上
            chk = True
        mx = int((cx+29)/60)
        if map_data[my][mx] == 0: # 右上
            chk = True
    if di == DIR_DOWN:
        mx = int((cx-30)/60)
        my = int((cy+29+dot)/60)
        if map_data[my][mx] == 0: # 左下
            chk = True
        mx = int((cx+29)/60)
        if map_data[my][mx] == 0: # 右下
            chk = True
    if di == DIR_LEFT:
        mx = int((cx-30-dot)/60)
        my = int((cy-30)/60)
        if map_data[my][mx] == 0: # 左上
            chk = True
        my = int((cy+29)/60)
        if map_data[my][mx] == 0: # 左下
            chk = True
    if di == DIR_RIGHT:
        mx = int((cx+29+dot)/60)
        my = int((cy-30)/60)
        if map_data[my][mx] == 0: # 右上
            chk = True
        my = int((cy+29)/60)
        if map_data[my][mx] == 0: # 右下
            chk = True
    return chk

def move_ao():    # AO を動かす＜stage 0＞
    global ao_x, ao_y, ao_d, ao_a, ao_p, tmr, get_p
    if key == "Up":
        ao_d = DIR_UP
        if check_wall(ao_x, ao_y, ao_d, 20) == False:
            ao_y = ao_y - 20
    if key == "Down":
        ao_d = DIR_DOWN
        if check_wall(ao_x, ao_y, ao_d, 20) == False:
            ao_y = ao_y + 20
    if key == "Left":
        ao_d = DIR_LEFT
        if check_wall(ao_x, ao_y, ao_d, 20) == False:
            ao_x = ao_x - 20
    if key == "Right":
        ao_d = DIR_RIGHT
        if check_wall(ao_x, ao_y, ao_d, 20) == False:
            ao_x = ao_x + 20
    ao_a = ao_d*3 + img_1[tmr%4]    # ANIMATION
    mx = int(ao_x/60)
    my = int(ao_y/60)
    if map_data[my][mx] == 3: # キャンディGET？
        map_data[my][mx] = 1
        get_p = get_p + 1

def move_oni0():    # ONI0 を動かす
    global idx, tmr, oni0_x, oni0_y, oni0_d, oni0_a
    speed = 10
    if oni0_x%60 == 30 and oni0_y%60 == 30:
        oni0_d = random.randint(0, 6)
        if stage == 0:
            if oni0_d >= 2:
                if ao_y < oni0_y:
                    oni0_d = DIR_UP
                if ao_y > oni0_y:
                    oni0_d = DIR_DOWN
                if ao_x < oni0_x:
                    oni0_d = DIR_LEFT
                if ao_x > oni0_x:
                    oni0_d = DIR_RIGHT
        else:
            if oni0_d >= 2:
                if red_y < oni0_y:
                    oni0_d = DIR_UP
                if red_y > oni0_y:
                    oni0_d = DIR_DOWN
                if red_x < oni0_x:
                    oni0_d = DIR_LEFT
                if red_x > oni0_x:
                    oni0_d = DIR_RIGHT                
    if oni0_d == DIR_UP:
        if check_wall(oni0_x, oni0_y, oni0_d, speed) == False:
            oni0_y = oni0_y - speed
    if oni0_d == DIR_DOWN:
        if check_wall(oni0_x, oni0_y, oni0_d, speed) == False:
            oni0_y = oni0_y + speed
    if oni0_d == DIR_LEFT:
        if check_wall(oni0_x, oni0_y, oni0_d, speed) == False:
            oni0_x = oni0_x - speed
    if oni0_d == DIR_RIGHT:
        if check_wall(oni0_x, oni0_y, oni0_d, speed) == False:
            oni0_x = oni0_x + speed
    oni0_a = img_4[tmr%10]   # ANIMATION
    if abs(oni0_x-ao_x) <= 40 and abs(oni0_y-ao_y) <= 40:
        idx = 2
        tmr = 0
    if abs(oni0_x-red_x) <= 40 and abs(oni0_y-red_y) <= 40:
        idx = 7
        tmr = 0

def move_red():   # RED を動かす＜stage 1＞
    global red_x, red_y, red_d, red_a, get_r, tmr
    if key == "Up":
        red_d = DIR_UP
        if check_wall(red_x, red_y, red_d, 20) == False:
            red_y = red_y - 20
    if key == "Down":
        red_d = DIR_DOWN
        if check_wall(red_x, red_y, red_d, 20) == False:
            red_y = red_y + 20
    if key == "Left":
        red_d = DIR_LEFT
        if check_wall(red_x, red_y, red_d, 20) == False:
            red_x = red_x - 20
    if key == "Right":
        red_d = DIR_RIGHT
        if check_wall(red_x, red_y, red_d, 20) == False:
            red_x = red_x + 20
    red_a = red_d*3 +img_1[tmr%4]   # ANIMATION
    mx = int(red_x/60)
    my = int(red_y/60)
    if map_data[my][mx] == 2: # キャンディに載ったか？
        map_data[my][mx] = 1
        get_r = get_r + 1

def move_oni2(): #   ONI2 （中央）を動かす
    global idx, tmr, oni2_x, oni2_y, oni2_d, oni2_a
    speed = 5
    if oni2_d == 2: #DIR_LEFT:
        if check_wall(oni2_x, oni2_y, oni2_d, speed) == False:
            oni2_x = oni2_x - speed
        else:
            oni2_d = 3 #DIR_RIGHT
    elif oni2_d == 3: #DIR_RIGHT:
        if check_wall(oni2_x, oni2_y, oni2_d, speed) == False:
            oni2_x = oni2_x + speed
        else:
            oni2_d = 2 #DIR_LEFT
    oni2_a = img_2[tmr%8]    # ANIMATION
    if stage == 0:
        if abs(oni2_x-ao_x) <= 40 and abs(oni2_y-ao_y) <= 40:
            idx = 2
            tmr = 0
    else:
        if abs(oni2_x-red_x) <= 40 and abs(oni2_y-red_y) <= 40:
            idx = 7
            tmr = 0

def move_oni1(): #   ONI1（右）を動かす
    global idx, tmr, oni1_x, oni1_y, oni1_d, oni1_a
    speed = 8
    if oni1_d == 0: #DIR_UP:
        if check_wall(oni1_x, oni1_y, oni1_d, speed) == False:
            oni1_y = oni1_y - speed
        else:
            oni1_d = 1 #DIR_DOWN
    elif oni1_d == 1: #DIR_DOWN:
        if check_wall(oni1_x, oni1_y, oni1_d, speed) == False:
            oni1_y = oni1_y + speed
        else:
            oni1_d = 0 #DIR_UP
    oni1_a = img_3[tmr%8]   # ANIMATION
    if stage == 0:
        if abs(oni1_x-ao_x) <= 40 and abs(oni1_y-ao_y) <= 40:
            idx = 2
            tmr = 0
    else:
        if abs(oni1_x-red_x) <= 40 and abs(oni1_y-red_y) <= 40:
            idx = 7
            tmr = 0

# ==================================================================================
def main(): # メインループ
    global key, koff, idx, tmr, stage
    global get_p, time_p, time_px, get_r, time_r, time_rx
    tmr = tmr + 1
    draw_screen()
    draw_txt("ゲットした数が多い方が勝ち。どちらも時間内に全てゲットした場合は、残り時間の多い方が勝ち。", 660, 20, 15, "yellow")

##### ---------------------------＜stege 0＞----------------------------------
    if idx == 0: # タイトル画面 
        stage = 0
        canvas.create_image(660, 380, image=img_title, tag="SCREEN")
        if tmr%10 < 5:
            draw_txt("Push SPACE", 360, 540, 30, "blue")
        if key == "space":
            time_p = 0
            get_p = 0
            time_r = 0
            get_r = 0
            time_r
            set_stage()
            set_pos()
            idx = 1

# -----  AO  -------------------------------------------            
    if idx == 1:  # ---------  AO のプレイ
        time_p = time_p + 1
        time_px = 80 - int(time_p/10) 
        move_ao()
        move_oni0()
        move_oni1()
        move_oni2()        
        if get_p == 25:
            idx = 4
            tmr = 0
        if time_px == 0:
            idx = 3
            tmr = 0
            
    if idx == 2:  # ---------  敵にやられた
        draw_txt("ヤラレタ！", ao_x, ao_y, 40, "black")
        if tmr == 20:
            set_pos()
            idx = 1

    if idx == 3:  # PEN  タイムオーバー
        draw_txt("タイムオーバー", 450, 540, 40, "blue")
        if tmr == 30:
            idx = 5
            tmr = 0

    if idx == 4:  # PEN  完了
        draw_txt("全てゲット！", 400, 540, 40, "blue")
        if tmr == 30:
            idx = 5
            tmr = 0
             
##### ---------------------------＜stege 1＞----------------------------------------
    if idx == 5: # タイトル画面 
        stage = 1
        if tmr%10 < 5:
            draw_txt("Push SPACE", 360, 230, 30, "red")
        if key == "space":
            time_r = 0
            get_r = 0
            set_stage()
            set_pos()
            idx = 6
            
   # -----  RED  ------------------------------------------
    if idx == 6:  # ---------  RED のプレイ
        time_r = time_r + 1
        time_rx = 80 - int(time_r/10) 
        move_red()
        move_oni0()
        move_oni1()
        move_oni2()        
        if get_r == 25:
            idx = 9
            tmr = 0
        if time_rx == 0:
            idx = 8
            tmr = 0
            
    if idx == 7:  # --------- 敵にやられた
        draw_txt("ヤラレタ！", red_x, red_y, 40, "black")
        if tmr == 20:
            set_pos()
            idx = 6

    if idx == 8:  # RED  タイムオーバー
        draw_txt("タイムオーバー", 450, 240, 40, "red")
        if tmr == 30:
            idx = 10
            tmr = 0

    if idx == 9:  # RED  完了
        draw_txt("全てゲット！", 400, 240, 40, "red")
        if tmr == 30:
            idx = 10
            tmr = 0

    if idx == 10: # ゲーム終了
        if tmr%10 < 8:
            if time_px == 0 & time_rx ==0:
                if get_r > get_p:
                    draw_txt("勝ち", 360, 240, 40, "red")
                if get_r < get_p:
                    draw_txt("勝ち", 360, 540, 40, "blue")
                if get_r == get_p:
                    draw_txt("引き分け", 360, 390, 40, "green")
            else:
                if time_rx > time_px:
                    draw_txt("勝ち", 360, 240, 40, "red")
                if time_rx < time_px:
                    draw_txt("勝ち", 360, 540, 40, "blue")
                if time_rx == time_px:
                    draw_txt("引き分け", 360, 390, 40, "green")
        if tmr == 50:
            idx = 0

    if koff == True:
        key = ""
        koff = False

    root.after(100, main)


root = tkinter.Tk()

img_bg = [
    tkinter.PhotoImage(file="image_daruma/kabe00.png"),
    tkinter.PhotoImage(file="image_daruma/kabe01.png"),
    tkinter.PhotoImage(file="image_daruma/kabe02.png"),
    tkinter.PhotoImage(file="image_daruma/kabe03.png")
]
img_ao = [
    tkinter.PhotoImage(file="image_daruma/ao00.png"),
    tkinter.PhotoImage(file="image_daruma/ao01.png"),
    tkinter.PhotoImage(file="image_daruma/ao02.png"),
    tkinter.PhotoImage(file="image_daruma/ao03.png"),
    tkinter.PhotoImage(file="image_daruma/ao04.png"),
    tkinter.PhotoImage(file="image_daruma/ao05.png"),
    tkinter.PhotoImage(file="image_daruma/ao06.png"),
    tkinter.PhotoImage(file="image_daruma/ao07.png"),
    tkinter.PhotoImage(file="image_daruma/ao08.png"),
    tkinter.PhotoImage(file="image_daruma/ao09.png"),
    tkinter.PhotoImage(file="image_daruma/ao10.png"),
    tkinter.PhotoImage(file="image_daruma/ao11.png"),
]
img_red = [
    tkinter.PhotoImage(file="image_daruma/red00.png"),
    tkinter.PhotoImage(file="image_daruma/red01.png"),
    tkinter.PhotoImage(file="image_daruma/red02.png"),
    tkinter.PhotoImage(file="image_daruma/red03.png"),
    tkinter.PhotoImage(file="image_daruma/red04.png"),
    tkinter.PhotoImage(file="image_daruma/red05.png"),
    tkinter.PhotoImage(file="image_daruma/red06.png"),
    tkinter.PhotoImage(file="image_daruma/red07.png"),
    tkinter.PhotoImage(file="image_daruma/red08.png"),
    tkinter.PhotoImage(file="image_daruma/red09.png"),
    tkinter.PhotoImage(file="image_daruma/red10.png"),
    tkinter.PhotoImage(file="image_daruma/red11.png")
]
img_oni0 = [
    tkinter.PhotoImage(file="image_daruma/oni00.png"),
    tkinter.PhotoImage(file="image_daruma/oni01.png"),
    tkinter.PhotoImage(file="image_daruma/oni02.png")
]
img_oni1 = [
    tkinter.PhotoImage(file="image_daruma/oni10.png"),
    tkinter.PhotoImage(file="image_daruma/oni11.png"),
    tkinter.PhotoImage(file="image_daruma/oni12.png")
]

img_title = tkinter.PhotoImage(file="image_daruma/daruma.png")

root.title("赤ダルマ vs 青ダルマ by T.Endou")
root.resizable(False, False)
root.bind("<KeyPress>", key_down)
root.bind("<KeyRelease>", key_up)
canvas = tkinter.Canvas(width=1320, height=780)
canvas.pack()
set_stage()
set_pos()
main()
root.mainloop()
